﻿var databaseObjects = new Array();
var dbColumns = new Array();
var foreignKeys = new Array();
var columnNamesListForSelect = new Array();
var columnNamesListForJoins = new Array();
var columnNamesListForFilters = new Array();

function DBObject(type, name, schema, alias, id)
{
    this.type = type;
    this.name = name;
    this.schema = schema;
    this.alias = alias;
    this.id = id;
    this.displayName = schema + "." + name;
}

function FindTableAlias(schema, name)
{
    thisTableDisplayName = schema + "." + name;
    thisTableAlias = "";
    for (var i=0; i<databaseObjects.length; i++)
    {
        if (databaseObjects[i].displayName == thisTableDisplayName)
        {
            thisTableAlias = databaseObjects[i].alias;
            break;
        }
    }
    //alert(thisTableDisplayName + " -- " + thisTableAlias);
    return thisTableAlias;
}

function ForeignKey(schema1, table1, table1alias, column1, schema2, table2, table2alias, column2, foreignkeyname)
{
    this.schema1 = schema1;
    this.table1 = table1;
    this.table1alias = table1alias;
    this.column1 = column1;
    this.schema2 = schema2;
    this.table2 = table2;
    this.table2alias = table2alias;
    this.column2 = column2;
    this.foreignkeyname = foreignkeyname;
}

function CheckForExistingAlias(tablealias)
{
    existingAlias = false;
    for (var ii=0; ii<databaseObjects.length; ii++)
    {
        if (databaseObjects[ii].alias == tablealias)
        {
            existingAlias = true;
            break;
        }
    }
    return existingAlias;
}

function FindDatabaseObjectByAlias(tableAlias)
{
    for (var i=0; i<databaseObjects.length; i++)
    {
        if (databaseObjects[i].alias == tableAlias)
        {
            return databaseObjects[i];
        }
    }
    return null;
}

function Column(id, name, parentType, parentId, parent, schema, type, dataType, tableAlias, isPrimaryKey)
{
    this.name = name;
    this.schema = schema;
    this.parent = parent;
    this.columnType = type;
    this.columnDataType = dataType;
    this.tableAlias = tableAlias;
    this.isColumnNumeric = (type == "N");
    this.isColumnNonNumeric = (type == "O");
    this.isAllColumns = (type == "*");
    this.columnDisplayName = tableAlias + "." + name;
    this.columnTableName = parent + "." + name;
    this.columnTableSchemaName = schema + "." + parent;
    this.fullColumnName = schema + "." + parent + "." + name;
    this.id = id;
    this.parentId = parentId;
    this.isPrimaryKey = isPrimaryKey;
    this.parentType = parentType;
}

function CompareDBObjects(a, b)
{
    if (a.schema > b.schema) { return 1; }
    if (a.name > b.name) { return 1; }
    return 0;
}


function FillDropDownList(dropDownList, selectedValue, textArray, valueArray, emptyDropdown)
{
    if (emptyDropdown)
    {
        dropDownList.options.length = 0;
    }
    numItemsInDropdown = dropDownList.options.length;
    for (var i=0; i<valueArray.length; i++)
    {
        if (selectedValue.indexOf(valueArray[i]) >= 0)
        {
           valueArray[i] = selectedValue;
           textArray[i] = selectedValue;
        }
        dropDownList.options[numItemsInDropdown+i] = new Option(textArray[i], valueArray[i]);
        if (valueArray[i] == selectedValue)
        {
            dropDownList.options[numItemsInDropdown+i].selected = true;
        }
    }
}
