﻿var tempTableJoinConditions = new Array();
var tempDuplicateJoinConditions = new Array();

function DeleteAllForeignKeys()
{
    foreignKeys = new Array();
}

function DeleteForeignKeysContainingTable(tableAlias)
{
    for (var i=foreignKeys.length-1; i>=0; i--)
    {
        if ((foreignKeys[i].table1alias == tableAlias) || (foreignKeys[i].table2alias == tableAlias))
        {
            foreignKeys = DeleteArrayElement(foreignKeys, i);
        }
    }
}

function UpdateForeignKeysTable2Alias(table2Schema, table2Name, table2Alias)
{
    for (var i=0; i<foreignKeys.length; i++)
    {
        if (foreignKeys[i].schema2 == table2Schema && foreignKeys[i].table2 == table2Name)
        {
            foreignKeys[i].table2alias = table2Alias;
        }
    }
}

function UpdateForeignKeysTable1Alias(table1Schema, table1Name, table1Alias)
{
    for (var i=0; i<foreignKeys.length; i++)
    {
        if (foreignKeys[i].schema1 == table1Schema && foreignKeys[i].table1 == table1Name)
        {
            foreignKeys[i].table1alias = table1Alias;
        }
    }
}

function AddForeignKeysConstraint(schema1, table1, table1alias, column1, schema2, table2, table2alias, column2, foreignkeyname)
{
    foreignKeys[foreignKeys.length] = new ForeignKey(schema1, table1, table1alias, column1, schema2, table2, table2alias, column2, foreignkeyname);
}

function CheckForExistingTablesInJoins(table1alias, table2alias)
{
    var indexOfExistingJoin = -1;
    for (var i=0; i<tableJoins.length; i++)
    {
        var thisTableJoin = tableJoins[i];
        if ((thisTableJoin.table1alias == table1alias && thisTableJoin.table2alias == table2alias) || (thisTableJoin.table2alias == table1alias && thisTableJoin.table1alias == table2alias))//Join is already created ... no worries mate
        {
            indexOfExistingJoin = i;
            break;            
        }
    }
    return indexOfExistingJoin;
}

function CheckForExistingColumnsInJoins(col1, col2)
{
    var indexOfExistingColumnInJoin = -1;
    for (var i=0; i<tableJoins.length; i++)
    {
        var thisTableJoin = tableJoins[i];
        var col1Join = thisTableJoin.table1alias + "." + thisTableJoin.column1;
        var col2Join = thisTableJoin.table2alias + "." + thisTableJoin.column2;
        if ((col1Join == col1 && col2Join == col2) || (col1Join == col2 && col2Join == col1))
        {
            indexOfExistingColumnInJoin = i;
            break;
        }
        var joinColumns = thisTableJoin.columnJoins;
        for (var j=0; j<joinColumns.length; j++)
        {
            col1col2jc = col1 + " = " + col2;
            col2col1jc = col2 + " = " + col1;
            if (joinColumns[j] == col1col2jc || joinColumns[j] == col2col1jc)
            {
                indexOfExistingColumnInJoin = i;
                break;
            }
        }
        if (indexOfExistingColumnInJoin >= 0) { break; }
    }
    return indexOfExistingColumnInJoin;
}

function CheckForTableInSelectedTables(tableDisplayName)
{
    
    var tableInJoinIsSelected = false;
    for (var i=0; i<databaseObjects.length; i++)
    {
        //alert(tableDisplayName + " : " + databaseObjects[i].displayName);
        if (trim(tableDisplayName) == trim(databaseObjects[i].displayName))
        {
            tableInJoinIsSelected = true;
            break;
        }
    }
    return tableInJoinIsSelected;
}

function AutoBuildJoins()
{
    tempTableJoinConditions = new Array();
    tempDuplicateJoinConditions = new Array();
    /*
    alert("a");
    strMsg = "";
    for (var k=0; k<foreignKeys.length; k++)
    {
        strMsg += foreignKeys[k].table1alias + "." + foreignKeys[k].column1 + " --- " + foreignKeys[k].table2alias + "." + foreignKeys[k].column2 + "\n";
    }
    alert(strMsg);
    */
    for (var k=0; k<foreignKeys.length; k++)
    {
        thisForeignKey = foreignKeys[k];
        if (CheckForTableInSelectedTables(thisForeignKey.schema1 + "." + thisForeignKey.table1) && CheckForTableInSelectedTables(thisForeignKey.schema2 + "." + thisForeignKey.table2))
        {
            var indexOfExistingJoin = CheckForExistingTablesInJoins(thisForeignKey.table1alias, thisForeignKey.table2alias);
            //alert("Here: " + thisForeignKey.table1alias + " : " + thisForeignKey.table2alias + " : " + indexOfExistingJoin);
            if (indexOfExistingJoin == -1)//not found
            {
            
                tempTableJoinConditions[tempTableJoinConditions.length] = new TableJoin("Inner Join", thisForeignKey.schema1, thisForeignKey.table1, thisForeignKey.table1alias, thisForeignKey.column1, thisForeignKey.schema2, thisForeignKey.table2, thisForeignKey.table2alias, thisForeignKey.column2, true)
            }
        }    
    }        
    //alert("b: " + tempTableJoinConditions.length);
    for (var i=0; i<tempTableJoinConditions.length-1; i++)
    {
        //alert(tempTableJoinConditions[i].tableJoinText);
        for (var j=tempTableJoinConditions.length-1; j>=i+1; j--)
        {
            if (tempTableJoinConditions[i].table1alias == tempTableJoinConditions[j].table1alias && tempTableJoinConditions[i].table2alias == tempTableJoinConditions[j].table2alias)
            {
                tempDuplicateJoinConditions[tempDuplicateJoinConditions.length] = tempTableJoinConditions[j];
                tempTableJoinConditions = DeleteArrayElement(tempTableJoinConditions, j);
                //strMsg += tempDuplicateJoinConditions[tempDuplicateJoinConditions.length-1].tableJoinText + "\n\n";
            }
        }
    }
    //alert("c");
    for (var i=0; i<tempTableJoinConditions.length; i++)
    {
        var tempAdditionalColumnJoins = new Array();
        for (var j=tempDuplicateJoinConditions.length-1; j>=0; j--)
        {
            if (tempTableJoinConditions[i].table1alias == tempDuplicateJoinConditions[j].table1alias && tempTableJoinConditions[i].table2alias == tempDuplicateJoinConditions[j].table2alias)
            {
               dupJoin = tempDuplicateJoinConditions[j];
               aJoin = tempTableJoinConditions[i];
               aJoin.columnJoins[aJoin.columnJoins.length] = dupJoin.table1alias + "." + dupJoin.column1 + " = " + dupJoin.table2alias + "." + dupJoin.column2;
               tempTableJoinConditions[i] = aJoin;       
               tempDuplicateJoinConditions = DeleteArrayElement(tempDuplicateJoinConditions, j);
            }
        }
        tempTableJoinConditions[i] = RebuildTableJoinText(tempTableJoinConditions[i]);
    }
    //alert("d");
    for (var i=0; i<tempTableJoinConditions.length; i++)
    {
        tableJoins[tableJoins.length] = tempTableJoinConditions[i];
        CreateJoinConditionRow(tempTableJoinConditions[i]);
    }
}

function CheckForExistingTempJoinCondition(table2alias)
{
    var tempJoinConditionExisting = false;
    for (var k=0; k<tempTableJoinConditions.length; k++)
    {
        if (tempTableJoinConditions[k].table2alias == table2alias)
        {
            tempJoinConditionExisting = true;
            break;
        }
    }
    return tempJoinConditionExisting;
}
